'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = wasMutated;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _lodashCollectionAny = require('lodash/collection/any');

var _lodashCollectionAny2 = _interopRequireDefault(_lodashCollectionAny);

function wasMutated(prevStateRef, prevState, state, isImmutable) {
  var sameParentRef = arguments.length <= 4 || arguments[4] === undefined ? true : arguments[4];

  if (prevState == null || state == null || isImmutable(prevState)) {
    if (sameParentRef) {
      return prevState !== state;
    }

    return false;
  }

  var sameRef = prevStateRef === state;

  // Gather all keys from prev and after states
  var keys = {};
  Object.keys(prevState).forEach(function (key) {
    keys[key] = true;
  });
  Object.keys(state).forEach(function (key) {
    keys[key] = true;
  });

  return (0, _lodashCollectionAny2['default'])(Object.keys(keys), function (key) {
    return wasMutated(prevStateRef[key], prevState[key], state[key], isImmutable, sameRef);
  });
}

module.exports = exports['default'];